#include <stdio.h>
#include "config_file.h"

#define WORD_CATALOGUE 0
#define WORD_INFORMATION 1
#define END_CATALOGUE 2
#define END_FILE 3
#define ERROR 4

#define SIZE_STRING 100

#define NBR_MAX_INFORMATIONS 100



Information *information_array[NBR_MAX_INFORMATIONS];

int index_array_information;

void init_config_file() {
  FILE *file;
  char *node, *catalogue, *executable_file, *path_executable_file;
  int index = 0;
  index_array_information = 0;
  while (index < NBR_MAX_INFORMATIONS) {
    information_array[index++] = NULL;
  }
  file = fopen("file_dispatcher.conf", "r");
  if (!file) {
    fprintf(stderr, "The file_dispatcher.conf file doesn't exist.\n");
    exit(0);
  }
  make_informations(file);
}

void make_informations(FILE *file) {
  // make the informations to read a file. 
  Information *an_information;
  do {
    an_information = (Information *)(malloc(sizeof(Information)));
    if (!an_information) {
      fprintf(stderr, "Not enough memory for information in config_file. \n");
      exit(0);
    }
    an_information -> catalogue = NULL;
    an_information -> executable_file = NULL;
    an_information -> path_executable_file = NULL;
    information_array[index_array_information++] = an_information;
  } while(make_information(file, an_information) != END_FILE);
}

int make_information(FILE *file, Information *an_information) {
  // return END_FILE if the cursor is the end of file else return END_NODE.
  int result, state = WORD_CATALOGUE;
  char *word; 
  struct node *a_node, *node_tmp;
  word = give_word(file, &result);
  // It's catalogue
  if (result != END_FILE) {
    if (result == WORD_CATALOGUE) {
      an_information -> catalogue = word;
      word = give_word(file, &result);
      // it's a executable_file.
      if (result == WORD_INFORMATION) {
	an_information -> executable_file = word;
	word = give_word(file, &result);
	// it's path_executable_file;
	if (result == WORD_INFORMATION) {
	  an_information -> path_executable_file = word;
	}
	else {
	  error_syntaxe("probleme avec le chemin d'acces de l'executable.");
	}
      }
      else {
	error_syntaxe("probleme avec l'executable.");
      }
    }
    else {
      error_syntaxe("probleme avec le catalogue.");
    }
    while (result == WORD_INFORMATION) {
      node_tmp = (struct node *)(malloc(sizeof(struct node)));
      if (!node_tmp) {
	fprintf(stderr, "Not enough memory for node_tmp in config_file. \n");
	exit(0);
      }
      node_tmp -> next_node = NULL;
      if (state == WORD_CATALOGUE) {
	an_information -> a_node = node_tmp;
	a_node = node_tmp;
	state = WORD_INFORMATION;
      }
    else {
      a_node -> next_node = node_tmp;
      a_node = node_tmp;
    }
      word = give_word(file, &result);
      if (result == END_CATALOGUE || result == WORD_INFORMATION) 
	a_node -> name = word;
    }
    if (result != END_CATALOGUE) {
      printf("caractere : %s\n", word);
      error_syntaxe("fin de catalogue.");
    }
  }
  return(result);
}

char *give_word(FILE *file, int *result) {
  char *string, character = 'a';
  int index = 0;
  string = (char *)(malloc(SIZE_STRING*sizeof(char)));
  if (!string) {
    fprintf(stderr, "Not enough memory string in config_file. \n");
    exit(0);
  }
  while (character != ':' && character != ',' && character != ';' && character != EOF) {
    character = (char)(fgetc(file));
    if (character != ' ' && character != '\n' && character != ':' && character != ',' && character != ';' && character != EOF) 
      *(string + index++) = character;
  }
  switch(character) {
  case ':' : *result = WORD_CATALOGUE; break;
  case ',' : *result = WORD_INFORMATION ; break;
  case ';' : *result = END_CATALOGUE; break;
  case EOF : *result = END_FILE; break;
  default : *result = ERROR;
  }
  *(string + index) = '\0';
  return(string);
}

void error_syntaxe(char *erreur) {
  fprintf(stderr, "ERROR SYNTAXE : %s \n", erreur);
  exit(0);
}

Information *give_information(char *catalogue) {
  // return the struct information which have the same catalogue.
  int index = 0;
  char *word;
  Information *an_information;
  an_information = information_array[index++];
  while (index < index_array_information && strcmp(an_information -> catalogue, catalogue)) {
    an_information = information_array[index++];
  }
  if (index >= index_array_information)
    an_information = NULL;
  return(an_information);
}

char *give_executable_file(Information *an_information) {
  // return the executable_file of an_information.
  return(an_information -> executable_file);
}

char *give_path_executable_file(Information *an_information) {
  // return the path_executable_file.
  return(an_information -> path_executable_file);
}

struct node *give_node(Information *an_information) {
  // return the nodes.
  return(an_information -> a_node);
}

int can_work_catalogue(char *catalogue, char *node) {
  // Return 1 if this catalogue is in this node else return 0.
  Information *an_information;
  struct node *a_node;
  int result = 0;
  // printf("catalogue = %s.\n", catalogue);
  // printf("node = %s.\n", node);
  an_information = give_information(catalogue);
  if (an_information != NULL) {
    // printf ("le catalogue est %s\n", an_information -> catalogue);
    a_node = give_node(an_information);
    while (a_node != NULL) {
      // printf("le node est %s\n", a_node -> name);
      if (strcmp(a_node -> name, node)) {}
      else {
	result = 1;
      }
      a_node = a_node -> next_node;
    }
  }
  // printf("result = %d.\n", result);
  return(result);
}

void show_informations() {
  int i;
  for (i=0 ; i < index_array_information ; i++) {
    printf("information[%d] : catalogue = %s\n", i, information_array[i] -> catalogue);
  }
}

/* int main() {
  Information *an_information;
  struct node *a_node = NULL;
  init_config_file();
  an_information = give_information("USNO_A2");
  printf("son fichier executable : %s.\n", give_executable_file(an_information));
  printf("le path de son executable : %s.\n", give_path_executable_file(an_information));
  a_node = give_node(an_information);
  while (a_node != NULL) {
    printf("Le noeud : %s.\n", a_node -> name);
    a_node = a_node -> next_node;
  }
  if (can_work_catalogue("2MASS", "node2.u-strasbg.fr")) {
    an_information = give_information("2MASS");
    printf("son fichier executable : %s.\n", give_executable_file(an_information));
    printf("le path de son executable : %s.\n", give_path_executable_file(an_information));
    a_node = give_node(an_information);
    while (a_node != NULL) {
      printf("Le noeud : %s.\n", a_node -> name);
      a_node = a_node -> next_node;
    }
  }
  else {
    printf("Ce catalogue n'existe pas dans ce noeud. \n");
  }
  return(1);
} */ 
