#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <signal.h>


#define MYPORT 3490    // the port users will be connecting to

#define BACKLOG 100     // how many pending connections queue will hold

#define SIZE_CONTROL 5000 // size (number of character) of the control. 
/* if size increase then the server send more controls. */

#define SIZE_ARRAY_CONTROL 7


void sigchld_handler(int s)
{
  while(wait(NULL) > 0);
}

int main()
{
  int sockfd, new_fd;  // listen on sock_fd, new connection on new_fd
  struct sockaddr_in my_addr;    // my address information
  struct sockaddr_in their_addr; // connector's address information
  int sin_size, numcar, index = 0, index_array = 4;
  struct sigaction sa;
  int yes=1;
  char buffer[100], *control, *array_controls[SIZE_ARRAY_CONTROL];

  if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
    perror("socket");
    exit(1);
  }
  
  if (setsockopt(sockfd,SOL_SOCKET,SO_REUSEADDR,&yes,sizeof(int)) == -1) {
    perror("setsockopt");
    exit(1);
  }
  
  my_addr.sin_family = AF_INET;         // host byte order
  my_addr.sin_port = htons(MYPORT);     // short, network byte order
  my_addr.sin_addr.s_addr = INADDR_ANY; // automatically fill with my IP
  memset(&(my_addr.sin_zero), '\0', 8); // zero the rest of the struct
  
  if (bind(sockfd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1) {
    perror("bind");
    exit(1);
  }
  if (listen(sockfd, BACKLOG) == -1) {
    perror("listen");
    exit(1);
  }
  
  sa.sa_handler = sigchld_handler; // reap all dead processes
  sigemptyset(&sa.sa_mask);
  sa.sa_flags = SA_RESTART;
  if (sigaction(SIGCHLD, &sa, NULL) == -1) {
    perror("sigaction");
    exit(1);
  }
  
  while(1) {  // main accept() loop
    sin_size = sizeof(struct sockaddr_in);
    if ((new_fd = accept(sockfd, (struct sockaddr *)&their_addr,
			 &sin_size)) == -1) {
      perror("accept");
      continue;
    }
    if (!fork()) { // this is the child process;
      close(sockfd); // child doesn't need the listener
      // initialisation the variables.
      control = (char *)(malloc(SIZE_CONTROL*sizeof(char)));
      array_controls[0] = control;
      strcpy(control, "mpirun");
      control = (char *)(malloc(SIZE_CONTROL*sizeof(char)));
      array_controls[1] = control;
      strcpy(control, "-np");
      control = (char *)(malloc(SIZE_CONTROL*sizeof(char)));
      array_controls[2] = control;
      strcpy(control, "6");
      control = (char *)(malloc(SIZE_CONTROL*sizeof(char)));
      array_controls[3] = control;
      strcpy(control, "dispatcher");
      printf("chemin = %s", control);

      // Reception the controls from a client.

      while (strcmp(buffer, "finish")) {
	printf("control.\n");
	index_array = 4;
	while (strcmp(buffer, "finish") && index_array < SIZE_ARRAY_CONTROL - 1) {
		control = (char *)(malloc(SIZE_CONTROL*sizeof(char)));
		if (!control) {
	  	fprintf(stderr, "Not enough memory for control buffer of server.\n");
	  	exit(1);
		}
		array_controls[index_array++] = control;
		index = 0;
		while (strcmp(buffer, "finish") && index < SIZE_CONTROL - 100) {
	  		if ((numcar = recv(new_fd, buffer, 99, 0)) == -1)
	    			perror("recv");
	  		buffer[numcar]='\0';
	  		printf("%s.\n", buffer);
	  		if (strcmp(buffer, "finish")) {
	    			sprintf((control + index), "%s|", buffer);
	    			index = index + numcar + 1;
				if (index < SIZE_CONTROL - 100 || index_array < SIZE_ARRAY_CONTROL - 1)
	  				send(new_fd, "encore", 7, 0);
			}
		}
      	}
	send(new_fd, "finish", 6, 0);
	// Case : the execvp control need the last element of array is null
	array_controls[index_array] = NULL;
      	int i, tube[2];
      	if (pipe(tube) == -1) { 
		perror("Ouverture pipe impossible"); 
		exit(1); 
      	} 
      	i=fork(); 
      
      	if (i==0) { 
		/* process fils */ 
		printf("on lance mpirun.\n");
		close(1); /* fermeture sortie std */ 
		dup2(tube[1], 1);  /* redirection sortie std sur descripteur en ecriture du tube */ 
		close(tube[0]);  /* fermeture du descripteur inutilise */  
		execvp("mpirun", array_controls); 
		free(control);
		// execlp("ls", "ls", NULL);
		perror("Lancement de mpirun"); 
      	} 
      
      	else { 
		int n;
		char ch[1024];
		/* process pere */ 
		close (tube[1]); 
		while((n = read(tube[0], ch, 1023))) {
	  		// fscanf(in,"%s", ch); // lecture du tube 
	  		ch[n] = 0;
	  		send(new_fd, ch, n, 0);
			printf("%s", ch); 
	  		recv(new_fd, ch, 7, 0);
	  		fflush(0);
		}
		system("sleep 1");
		send(new_fd, "finish", 6, 0);
		recv(new_fd, ch, 7, 0);
		// fclose(in); 
      	} 
	free(array_controls[4]);
	if (array_controls[5] != NULL)
		free(array_controls[5]);
      }
      // Communication is terminated.
      close(new_fd);
      exit(0);
    }   
    close(new_fd);  // parent doesn't need this
    }
  
  return 0;
} 

